/* -*- Mode: C -*-
 *
 * File: unicruft_cmdparser.c
 * Description: Code for command-line parser struct gengetopt_args_info.
 *
 * File autogenerated by optgen.perl version 0.06
 * generated with the following command:
 * /usr/local/bin/optgen.perl -u -l --no-handle-rcfile --nopod -F unicruft_cmdparser unicruft.gog
 *
 * The developers of optgen.perl consider the fixed text that goes in all
 * optgen.perl output files to be in the public domain:
 * we make no copyright claims on it.
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <unistd.h>
#include <ctype.h>

/* If we use autoconf/autoheader.  */
#ifdef HAVE_CONFIG_H
# include "config.h"
#endif

#ifdef HAVE_PWD_H
# include <pwd.h>
#endif

/* Allow user-overrides for PACKAGE and VERSION */
#ifndef PACKAGE
#  define PACKAGE "PACKAGE"
#endif

#ifndef VERSION
#  define VERSION "VERSION"
#endif


#ifndef PROGRAM
# define PROGRAM "unicruft"
#endif

/* #define cmdline_parser_DEBUG */

/* Check for "configure's" getopt check result.  */
#ifndef HAVE_GETOPT_LONG
# include "getopt.h"
#else
# include <getopt.h>
#endif

#include "unicruft_cmdparser.h"


/* user code section */

/* end user  code section */


void
cmdline_parser_print_version (void)
{
  printf("unicruft (%s %s) by Bryan Jurish <jurish@bbaw.de>\n", PACKAGE, VERSION);
}

void
cmdline_parser_print_help (void)
{
  cmdline_parser_print_version ();
  printf("\n");
  printf("Purpose:\n");
  printf("  Approximating UTF-8 transliteration & recoding\n");
  printf("\n");
  
  printf("Usage: %s [OPTIONS]... FILE(s)\n", "unicruft");
  
  printf("\n");
  printf(" Arguments:\n");
  printf("   FILE(s)  Input text file(s)\n");
  
  printf("\n");
  printf(" Options:\n");
  printf("   -h      --help                 Print help and exit.\n");
  printf("   -V      --version              Print version and exit.\n");
  printf("   -mMODE  --mode=MODE            Conversion mode (lu|ua|ul|ud|uL|uD|uDpp)\n");
  printf("   -u      --latin1-to-utf8       Convert Latin-1 to UTF-8\n");
  printf("   -a      --utf8-to-ascii        Convert UTF-8 to ASCII (default)\n");
  printf("   -l      --utf8-to-latin1       Convert UTF-8 to Latin-1\n");
  printf("   -d      --utf8-to-latin1-de    Convert UTF-8 to Latin-1/DE\n");
  printf("   -L      --utf8-to-utf8-latin1  Convert UTF-8 to UTF-8/Latin-1\n");
  printf("   -D      --utf8-to-utf8-de      Convert UTF-8 to UTF-8/DE\n");
  printf("   -P      --utf8-to-utf8-de-pp   (debug) run only the UTF-8/DE preprocessor\n");
  printf("   -oFILE  --output=FILE          Output file (default=stdout).\n");
}

#if defined(HAVE_STRDUP) || defined(strdup)
# define gog_strdup strdup
#else
/* gog_strdup(): automatically generated from strdup.c. */
/* strdup.c replacement of strdup, which is not standard */
static char *
gog_strdup (const char *s)
{
  char *result = (char*)malloc(strlen(s) + 1);
  if (result == (char*)0)
    return (char*)0;
  strcpy(result, s);
  return result;
}
#endif /* HAVE_STRDUP */

/* clear_args(args_info): clears all args & resets to defaults */
static void
clear_args(struct gengetopt_args_info *args_info)
{
  args_info->mode_arg = gog_strdup("ua"); 
  args_info->output_arg = gog_strdup("-"); 
}


int
cmdline_parser (int argc, char * const *argv, struct gengetopt_args_info *args_info)
{
  int c;	/* Character of the parsed option.  */
  int missing_required_options = 0;	

  args_info->help_given = 0;
  args_info->version_given = 0;
  args_info->mode_given = 0;
  args_info->latin1_to_utf8_given = 0;
  args_info->utf8_to_ascii_given = 0;
  args_info->utf8_to_latin1_given = 0;
  args_info->utf8_to_latin1_de_given = 0;
  args_info->utf8_to_utf8_latin1_given = 0;
  args_info->utf8_to_utf8_de_given = 0;
  args_info->utf8_to_utf8_de_pp_given = 0;
  args_info->output_given = 0;

  clear_args(args_info);

  /* rcfile handling */
  
  /* end rcfile handling */

  optarg = 0;
  optind = 1;
  opterr = 1;
  optopt = '?';

  while (1)
    {
      int option_index = 0;
      static struct option long_options[] = {
	{ "help", 0, NULL, 'h' },
	{ "version", 0, NULL, 'V' },
	{ "mode", 1, NULL, 'm' },
	{ "latin1-to-utf8", 0, NULL, 'u' },
	{ "utf8-to-ascii", 0, NULL, 'a' },
	{ "utf8-to-latin1", 0, NULL, 'l' },
	{ "utf8-to-latin1-de", 0, NULL, 'd' },
	{ "utf8-to-utf8-latin1", 0, NULL, 'L' },
	{ "utf8-to-utf8-de", 0, NULL, 'D' },
	{ "utf8-to-utf8-de-pp", 0, NULL, 'P' },
	{ "output", 1, NULL, 'o' },
        { NULL,	0, NULL, 0 }
      };
      static char short_options[] = {
	'h',
	'V',
	'm', ':',
	'u',
	'a',
	'l',
	'd',
	'L',
	'D',
	'P',
	'o', ':',
	'\0'
      };

      c = getopt_long (argc, argv, short_options, long_options, &option_index);

      if (c == -1) break;	/* Exit from 'while (1)' loop.  */

      if (cmdline_parser_parse_option(c, long_options[option_index].name, optarg, args_info) != 0) {
	exit (EXIT_FAILURE);
      }
    } /* while */

  

  if ( missing_required_options )
    exit (EXIT_FAILURE);

  
  if (optind < argc) {
      int i = 0 ;
      args_info->inputs_num = argc - optind ;
      args_info->inputs = (char **)(malloc ((args_info->inputs_num)*sizeof(char *))) ;
      while (optind < argc)
        args_info->inputs[ i++ ] = gog_strdup (argv[optind++]) ; 
  }

  return 0;
}


/* Parse a single option */
int
cmdline_parser_parse_option(char oshort, const char *olong, const char *val,
			       struct gengetopt_args_info *args_info)
{
  if (!oshort && !(olong && *olong)) return 1;  /* ignore null options */

#ifdef cmdline_parser_DEBUG
  fprintf(stderr, "parse_option(): oshort='%c', olong='%s', val='%s'\n", oshort, olong, val);*/
#endif

  switch (oshort)
    {
      case 'h':	 /* Print help and exit. */
          clear_args(args_info);
          cmdline_parser_print_help();
          exit(EXIT_SUCCESS);
        
          break;
        
        case 'V':	 /* Print version and exit. */
          clear_args(args_info);
          cmdline_parser_print_version();
          exit(EXIT_SUCCESS);
        
          break;
        
        case 'm':	 /* Conversion mode (lu|ua|ul|ud|uL|uD|uDpp) */
          args_info->mode_given++;
          if (args_info->mode_arg) free(args_info->mode_arg);
          args_info->mode_arg = gog_strdup(val);
          break;
        
        case 'u':	 /* Convert Latin-1 to UTF-8 */
          args_info->latin1_to_utf8_given++;
          /* user code */
          args_info->mode_arg="lu";
          break;
        
        case 'a':	 /* Convert UTF-8 to ASCII (default) */
          args_info->utf8_to_ascii_given++;
          /* user code */
          args_info->mode_arg="ua";
          break;
        
        case 'l':	 /* Convert UTF-8 to Latin-1 */
          args_info->utf8_to_latin1_given++;
          /* user code */
          args_info->mode_arg="ul";
          break;
        
        case 'd':	 /* Convert UTF-8 to Latin-1/DE */
          args_info->utf8_to_latin1_de_given++;
          /* user code */
          args_info->mode_arg="ud";
          break;
        
        case 'L':	 /* Convert UTF-8 to UTF-8/Latin-1 */
          args_info->utf8_to_utf8_latin1_given++;
          /* user code */
          args_info->mode_arg="uL";
          break;
        
        case 'D':	 /* Convert UTF-8 to UTF-8/DE */
          args_info->utf8_to_utf8_de_given++;
          /* user code */
          args_info->mode_arg="uD";
          break;
        
        case 'P':	 /* (debug) run only the UTF-8/DE preprocessor */
          args_info->utf8_to_utf8_de_pp_given++;
          /* user code */
          args_info->mode_arg="uDpp";
          break;
        
        case 'o':	 /* Output file (default=stdout). */
          args_info->output_given++;
          if (args_info->output_arg) free(args_info->output_arg);
          args_info->output_arg = gog_strdup(val);
          break;
        
        case 0:	 /* Long option(s) with no short form */
        /* Print help and exit. */
          if (strcmp(olong, "help") == 0) {
            clear_args(args_info);
            cmdline_parser_print_help();
            exit(EXIT_SUCCESS);
          
          }
          
          /* Print version and exit. */
          else if (strcmp(olong, "version") == 0) {
            clear_args(args_info);
            cmdline_parser_print_version();
            exit(EXIT_SUCCESS);
          
          }
          
          /* Conversion mode (lu|ua|ul|ud|uL|uD|uDpp) */
          else if (strcmp(olong, "mode") == 0) {
            args_info->mode_given++;
            if (args_info->mode_arg) free(args_info->mode_arg);
            args_info->mode_arg = gog_strdup(val);
          }
          
          /* Convert Latin-1 to UTF-8 */
          else if (strcmp(olong, "latin1-to-utf8") == 0) {
            args_info->latin1_to_utf8_given++;
            /* user code */
            args_info->mode_arg="lu";
          }
          
          /* Convert UTF-8 to ASCII (default) */
          else if (strcmp(olong, "utf8-to-ascii") == 0) {
            args_info->utf8_to_ascii_given++;
            /* user code */
            args_info->mode_arg="ua";
          }
          
          /* Convert UTF-8 to Latin-1 */
          else if (strcmp(olong, "utf8-to-latin1") == 0) {
            args_info->utf8_to_latin1_given++;
            /* user code */
            args_info->mode_arg="ul";
          }
          
          /* Convert UTF-8 to Latin-1/DE */
          else if (strcmp(olong, "utf8-to-latin1-de") == 0) {
            args_info->utf8_to_latin1_de_given++;
            /* user code */
            args_info->mode_arg="ud";
          }
          
          /* Convert UTF-8 to UTF-8/Latin-1 */
          else if (strcmp(olong, "utf8-to-utf8-latin1") == 0) {
            args_info->utf8_to_utf8_latin1_given++;
            /* user code */
            args_info->mode_arg="uL";
          }
          
          /* Convert UTF-8 to UTF-8/DE */
          else if (strcmp(olong, "utf8-to-utf8-de") == 0) {
            args_info->utf8_to_utf8_de_given++;
            /* user code */
            args_info->mode_arg="uD";
          }
          
          /* (debug) run only the UTF-8/DE preprocessor */
          else if (strcmp(olong, "utf8-to-utf8-de-pp") == 0) {
            args_info->utf8_to_utf8_de_pp_given++;
            /* user code */
            args_info->mode_arg="uDpp";
          }
          
          /* Output file (default=stdout). */
          else if (strcmp(olong, "output") == 0) {
            args_info->output_given++;
            if (args_info->output_arg) free(args_info->output_arg);
            args_info->output_arg = gog_strdup(val);
          }
          
          else {
            fprintf(stderr, "%s: unknown long option '%s'.\n", PROGRAM, olong);
            return (EXIT_FAILURE);
          }
          break;

        case '?':	 /* Invalid Option */
          fprintf(stderr, "%s: unknown option '%s'.\n", PROGRAM, olong);
          return (EXIT_FAILURE);


        default:	/* bug: options not considered.  */
          fprintf (stderr, "%s: option unknown: %c\n", PROGRAM, oshort);
          abort ();
        } /* switch */
  return 0;
}


/* Initialize options not yet given from environmental defaults */
void
cmdline_parser_envdefaults(struct gengetopt_args_info *args_info)
{
  

  return;
}


/* Load option values from an .rc file */
void
cmdline_parser_read_rcfile(const char *filename,
			      struct gengetopt_args_info *args_info,
			      int user_specified)
{
  char *fullname;
  FILE *rcfile;

  if (!filename) return; /* ignore NULL filenames */

#if defined(HAVE_GETUID) && defined(HAVE_GETPWUID)
  if (*filename == '~') {
    /* tilde-expansion hack */
    struct passwd *pwent = getpwuid(getuid());
    if (!pwent) {
      fprintf(stderr, "%s: user-id %d not found!\n", PROGRAM, getuid());
      return;
    }
    if (!pwent->pw_dir) {
      fprintf(stderr, "%s: home directory for user-id %d not found!\n", PROGRAM, getuid());
      return;
    }
    fullname = (char *)malloc(strlen(pwent->pw_dir)+strlen(filename));
    strcpy(fullname, pwent->pw_dir);
    strcat(fullname, filename+1);
  } else {
    fullname = gog_strdup(filename);
  }
#else /* !(defined(HAVE_GETUID) && defined(HAVE_GETPWUID)) */
  fullname = gog_strdup(filename);
#endif /* defined(HAVE_GETUID) && defined(HAVE_GETPWUID) */

  /* try to open */
  rcfile = fopen(fullname,"r");
  if (!rcfile) {
    if (user_specified) {
      fprintf(stderr, "%s: warning: open failed for rc-file '%s': %s\n",
	      PROGRAM, fullname, strerror(errno));
    }
  }
  else {
   cmdline_parser_read_rc_stream(rcfile, fullname, args_info);
  }

  /* cleanup */
  if (fullname != filename) free(fullname);
  if (rcfile) fclose(rcfile);

  return;
}


/* Parse option values from an .rc file : guts */
#define OPTPARSE_GET 32
void
cmdline_parser_read_rc_stream(FILE *rcfile,
				 const char *filename,
				 struct gengetopt_args_info *args_info)
{
  char *optname  = (char *)malloc(OPTPARSE_GET);
  char *optval   = (char *)malloc(OPTPARSE_GET);
  size_t onsize  = OPTPARSE_GET;
  size_t ovsize  = OPTPARSE_GET;
  size_t onlen   = 0;
  size_t ovlen   = 0;
  int    lineno  = 0;
  char c;

#ifdef cmdline_parser_DEBUG
  fprintf(stderr, "cmdline_parser_read_rc_stream('%s'):\n", filename);
#endif

  while ((c = fgetc(rcfile)) != EOF) {
    onlen = 0;
    ovlen = 0;
    lineno++;

    /* -- get next option-name */
    /* skip leading space and comments */
    if (isspace(c)) continue;
    if (c == '#') {
      while ((c = fgetc(rcfile)) != EOF) {
	if (c == '\n') break;
      }
      continue;
    }

    /* parse option-name */
    while (c != EOF && c != '=' && !isspace(c)) {
      /* re-allocate if necessary */
      if (onlen >= onsize-1) {
	char *tmp = (char *)malloc(onsize+OPTPARSE_GET);
	strcpy(tmp,optname);
	free(optname);

	onsize += OPTPARSE_GET;
	optname = tmp;
      }
      optname[onlen++] = c;
      c = fgetc(rcfile);
    }
    optname[onlen++] = '\0';

#ifdef cmdline_parser_DEBUG
    fprintf(stderr, "cmdline_parser_read_rc_stream('%s'): line %d: optname='%s'\n",
	    filename, lineno, optname);
#endif

    /* -- get next option-value */
    /* skip leading space */
    while ((c = fgetc(rcfile)) != EOF && isspace(c)) {
      ;
    }

    /* parse option-value */
    while (c != EOF && c != '\n') {
      /* re-allocate if necessary */
      if (ovlen >= ovsize-1) {
	char *tmp = (char *)malloc(ovsize+OPTPARSE_GET);
	strcpy(tmp,optval);
	free(optval);
	ovsize += OPTPARSE_GET;
	optval = tmp;
      }
      optval[ovlen++] = c;
      c = fgetc(rcfile);
    }
    optval[ovlen++] = '\0';

    /* now do the action for the option */
    if (cmdline_parser_parse_option('\0',optname,optval,args_info) != 0) {
      fprintf(stderr, "%s: error in file '%s' at line %d.\n", PROGRAM, filename, lineno);
      
    }
  }

  /* cleanup */
  free(optname);
  free(optval);

  return;
}
